﻿#include "hmg.ch"


FUNCTION Main()

  DEFINE WINDOW ReportWnd;
    ROW      0;
    COL      0;
    WIDTH  195;
    HEIGHT 100;
    TITLE  "Report in SumatraPDF";
    MAIN;
    MINBUTTON .F.;
    MAXBUTTON .F.;
    NOSIZE

    DEFINE BUTTON ShowBU
      ROW      25
      COL      45
      WIDTH   100
      HEIGHT   25
      CAPTION "Show report"
      ACTION  Sumatra_Create("hmg-help.pdf")
    END BUTTON

    ON KEY ESCAPE ACTION ThisWindow.RELEASE
  END WINDOW

  ReportWnd.CENTER
  ReportWnd.ACTIVATE

RETURN NIL


FUNCTION Sumatra_Create(cPdfFile)
  LOCAL cExeFile := "SumatraPDF.exe"

  IF ! File(cExeFile)
    MsgStop(cExeFile + " does not exist!")
    RETURN NIL
  ENDIF

  DEFINE WINDOW SumatraWnd;
    ROW      0;
    COL      0;
    WIDTH  700;
    HEIGHT 500;
    TITLE  "Report: " + cPdfFile;
    CHILD;
    ON SIZE     Sumatra_Size();
    ON MAXIMIZE Sumatra_Size();
    ON GOTFOCUS Sumatra_Size()

    ON KEY ESCAPE ACTION ThisWindow.RELEASE
  END WINDOW

  DisableWindow(ReportWnd.HANDLE)
	SumatraWnd.CenterIn(ReportWnd)

	EXECUTE FILE '"' + cExeFile + '"' PARAMETERS '-lang en -plugin ' + LTrim(Str(SumatraWnd.HANDLE)) + ' "' + cPdfFile + '"'

  Sumatra_Bookmarks(SumatraWnd.HANDLE)

	SumatraWnd.ACTIVATE
  EnableWindow(ReportWnd.HANDLE)

RETURN NIL


FUNCTION Sumatra_Bookmarks(nHSumatraWnd)
  LOCAL nHSumatraFrame

  DO WHILE (nHSumatraFrame := FindWindowEx(nHSumatraWnd, 0, "SUMATRA_PDF_FRAME", 0)) == 0
    HB_IdleSleep(0.05)
  ENDDO

  PostMessage(nHSumatraFrame, 273 /*WM_COMMAND*/, 417 /*IDM_VIEW_BOOKMARKS*/, 0)

RETURN NIL


FUNCTION Sumatra_Size()
  LOCAL nHSumatraFrame := FindWindowEx(SumatraWnd.HANDLE, 0, "SUMATRA_PDF_FRAME", 0)

  SetWindowPos(nHSumatraFrame, 0, 0, 0, SumatraWnd.CLIENTAREAWIDTH, SumatraWnd.CLIENTAREAHEIGHT, 0x0016 /*SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE*/)

  RedrawWindow(nHSumatraFrame)

RETURN NIL
